diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/post.php ./wordpress-3.4/wp-includes/post.php
*** ./wordpress-3.3.2/wp-includes/post.php	2011-11-23 18:20:21.000000000 -0600
--- ./wordpress-3.4/wp-includes/post.php	2012-05-13 02:41:47.000000000 -0500
***************
*** 2015,2048 ****
  	$wpdb->update( $wpdb->posts, $parent_data, $parent_where + array( 'post_type' => 'attachment' ) );
  
  	$comment_ids = $wpdb->get_col( $wpdb->prepare( "SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID = %d", $postid ));
! 	if ( ! empty($comment_ids) ) {
! 		do_action( 'delete_comment', $comment_ids );
! 		foreach ( $comment_ids as $comment_id )
! 			wp_delete_comment( $comment_id, true );
! 		do_action( 'deleted_comment', $comment_ids );
! 	}
  
  	$post_meta_ids = $wpdb->get_col( $wpdb->prepare( "SELECT meta_id FROM $wpdb->postmeta WHERE post_id = %d ", $postid ));
! 	if ( !empty($post_meta_ids) ) {
! 		do_action( 'delete_postmeta', $post_meta_ids );
! 		$in_post_meta_ids = "'" . implode("', '", $post_meta_ids) . "'";
! 		$wpdb->query( "DELETE FROM $wpdb->postmeta WHERE meta_id IN($in_post_meta_ids)" );
! 		do_action( 'deleted_postmeta', $post_meta_ids );
! 	}
  
  	do_action( 'delete_post', $postid );
! 	$wpdb->query( $wpdb->prepare( "DELETE FROM $wpdb->posts WHERE ID = %d", $postid ));
  	do_action( 'deleted_post', $postid );
  
! 	if ( 'page' == $post->post_type ) {
! 		clean_page_cache($postid);
  
  		foreach ( (array) $children as $child )
! 			clean_page_cache($child->ID);
! 
! 		$wp_rewrite->flush_rules(false);
! 	} else {
! 		clean_post_cache($postid);
  	}
  
  	wp_clear_scheduled_hook('publish_future_post', array( $postid ) );
--- 2073,2094 ----
  	$wpdb->update( $wpdb->posts, $parent_data, $parent_where + array( 'post_type' => 'attachment' ) );
  
  	$comment_ids = $wpdb->get_col( $wpdb->prepare( "SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID = %d", $postid ));
! 	foreach ( $comment_ids as $comment_id )
! 		wp_delete_comment( $comment_id, true );
  
  	$post_meta_ids = $wpdb->get_col( $wpdb->prepare( "SELECT meta_id FROM $wpdb->postmeta WHERE post_id = %d ", $postid ));
! 	foreach ( $post_meta_ids as $mid )
! 		delete_metadata_by_mid( 'post', $mid );
  
  	do_action( 'delete_post', $postid );
! 	$wpdb->delete( $wpdb->posts, array( 'ID' => $postid ) );
  	do_action( 'deleted_post', $postid );
  
! 	clean_post_cache( $post );
  
+ 	if ( is_post_type_hierarchical( $post->post_type ) ) {
  		foreach ( (array) $children as $child )
! 			clean_post_cache( $child );
  	}
  
  	wp_clear_scheduled_hook('publish_future_post', array( $postid ) );
***************
*** 2400,2406 ****
   *
   * @since 1.0.0
   * @uses $wpdb
-  * @uses $wp_rewrite
   * @uses $user_ID
   * @uses do_action() Calls 'pre_post_update' on post ID if this is an update.
   * @uses do_action() Calls 'edit_post' action on post ID and post data if this is an update.
--- 2446,2451 ----
***************
*** 2413,2419 ****
   * @return int|WP_Error The value 0 or WP_Error on failure. The post ID on success.
   */
  function wp_insert_post($postarr, $wp_error = false) {
! 	global $wpdb, $wp_rewrite, $user_ID;
  
  	$defaults = array('post_status' => 'draft', 'post_type' => 'post', 'post_author' => $user_ID,
  		'ping_status' => get_option('default_ping_status'), 'post_parent' => 0,
--- 2458,2464 ----
   * @return int|WP_Error The value 0 or WP_Error on failure. The post ID on success.
   */
  function wp_insert_post($postarr, $wp_error = false) {
! 	global $wpdb, $user_ID;
  
  	$defaults = array('post_status' => 'draft', 'post_type' => 'post', 'post_author' => $user_ID,
  		'ping_status' => get_option('default_ping_status'), 'post_parent' => 0,
***************
*** 2482,2488 ****
  	if ( 'pending' == $post_status && !current_user_can( 'publish_posts' ) )
  		$post_name = '';
  
! 	// Create a valid post name.  Drafts and pending posts are allowed to have an empty
  	// post name.
  	if ( empty($post_name) ) {
  		if ( !in_array( $post_status, array( 'draft', 'pending', 'auto-draft' ) ) )
--- 2527,2533 ----
  	if ( 'pending' == $post_status && !current_user_can( 'publish_posts' ) )
  		$post_name = '';
  
! 	// Create a valid post name. Drafts and pending posts are allowed to have an empty
  	// post name.
  	if ( empty($post_name) ) {
  		if ( !in_array( $post_status, array( 'draft', 'pending', 'auto-draft' ) ) )
***************
*** 2537,2543 ****
  		$ping_status = get_option('default_ping_status');
  
  	if ( isset($to_ping) )
! 		$to_ping = preg_replace('|\s+|', "\n", $to_ping);
  	else
  		$to_ping = '';
  
--- 2582,2588 ----
  		$ping_status = get_option('default_ping_status');
  
  	if ( isset($to_ping) )
! 		$to_ping = sanitize_trackback_urls( $to_ping );
  	else
  		$to_ping = '';
  
***************
*** 2622,2631 ****
  
  	$current_guid = get_post_field( 'guid', $post_ID );
  
! 	if ( 'page' == $data['post_type'] )
! 		clean_page_cache($post_ID);
! 	else
! 		clean_post_cache($post_ID);
  
  	// Set GUID
  	if ( !$update && '' == $current_guid )
--- 2667,2673 ----
  
  	$current_guid = get_post_field( 'guid', $post_ID );
  
! 	clean_post_cache( $post_ID );
  
  	// Set GUID
  	if ( !$update && '' == $current_guid )
***************
*** 2890,2895 ****
--- 2930,2936 ----
   *
   * @param int $post_id Post ID.
   * @param string $tags The tags to set for the post, separated by commas.
+  * @param string $taxonomy Taxonomy name. Defaults to 'post_tag'.
   * @param bool $append If true, don't delete existing tags, just add on. If false, replace the tags with the new tags.
   * @return mixed Array of affected term IDs. WP_Error or false on failure.
   */
***************
*** 2902,2908 ****
  	if ( empty($tags) )
  		$tags = array();
  
! 	$tags = is_array($tags) ? $tags : explode( ',', trim($tags, " \n\t\r\0\x0B,") );
  
  	// Hierarchical taxonomies must always pass IDs rather than names so that children with the same
  	// names but different parents aren't confused.
--- 2943,2954 ----
  	if ( empty($tags) )
  		$tags = array();
  
! 	if ( ! is_array( $tags ) ) {
! 		$comma = _x( ',', 'tag delimiter' );
! 		if ( ',' !== $comma )
! 			$tags = str_replace( $comma, ',', $tags );
! 		$tags = explode( ',', trim( $tags, " \n\t\r\0\x0B," ) );
! 	}
  
  	// Hierarchical taxonomies must always pass IDs rather than names so that children with the same
  	// names but different parents aren't confused.
***************
*** 3026,3032 ****
  		if ( 'enclosure' != $key || !is_array( $val ) )
  			continue;
  		foreach( $val as $enc ) {
! 			$enclosure = split( "\n", $enc );
  			$pung[] = trim( $enclosure[ 0 ] );
  		}
  	}
--- 3072,3078 ----
  		if ( 'enclosure' != $key || !is_array( $val ) )
  			continue;
  		foreach( $val as $enc ) {
! 			$enclosure = explode( "\n", $enc );
  			$pung[] = trim( $enclosure[ 0 ] );
  		}
  	}
***************
*** 3064,3070 ****
  function get_to_ping($post_id) {
  	global $wpdb;
  	$to_ping = $wpdb->get_var( $wpdb->prepare( "SELECT to_ping FROM $wpdb->posts WHERE ID = %d", $post_id ));
! 	$to_ping = trim($to_ping);
  	$to_ping = preg_split('/\s/', $to_ping, -1, PREG_SPLIT_NO_EMPTY);
  	$to_ping = apply_filters('get_to_ping',  $to_ping);
  	return $to_ping;
--- 3110,3116 ----
  function get_to_ping($post_id) {
  	global $wpdb;
  	$to_ping = $wpdb->get_var( $wpdb->prepare( "SELECT to_ping FROM $wpdb->posts WHERE ID = %d", $post_id ));
! 	$to_ping = sanitize_trackback_urls( $to_ping );
  	$to_ping = preg_split('/\s/', $to_ping, -1, PREG_SPLIT_NO_EMPTY);
  	$to_ping = apply_filters('get_to_ping',  $to_ping);
  	return $to_ping;
***************
*** 3116,3122 ****
  function get_all_page_ids() {
  	global $wpdb;
  
! 	if ( ! $page_ids = wp_cache_get('all_page_ids', 'posts') ) {
  		$page_ids = $wpdb->get_col("SELECT ID FROM $wpdb->posts WHERE post_type = 'page'");
  		wp_cache_add('all_page_ids', $page_ids, 'posts');
  	}
--- 3162,3169 ----
  function get_all_page_ids() {
  	global $wpdb;
  
! 	$page_ids = wp_cache_get('all_page_ids', 'posts');
! 	if ( ! is_array( $page_ids ) ) {
  		$page_ids = $wpdb->get_col("SELECT ID FROM $wpdb->posts WHERE post_type = 'page'");
  		wp_cache_add('all_page_ids', $page_ids, 'posts');
  	}
***************
*** 3509,3515 ****
  	}
  
  	// Update cache.
! 	update_page_cache($pages);
  
  	if ( $child_of || $hierarchical )
  		$pages = & get_page_children($child_of, $pages);
--- 3556,3562 ----
  	}
  
  	// Update cache.
! 	update_post_cache( $pages );
  
  	if ( $child_of || $hierarchical )
  		$pages = & get_page_children($child_of, $pages);
***************
*** 3725,3731 ****
  	if ( $file )
  		update_attached_file( $post_ID, $file );
  
! 	clean_post_cache($post_ID);
  
  	if ( ! empty( $context ) )
  		add_post_meta( $post_ID, '_wp_attachment_context', $context, true );
--- 3772,3778 ----
  	if ( $file )
  		update_attached_file( $post_ID, $file );
  
! 	clean_post_cache( $post_ID );
  
  	if ( ! empty( $context ) )
  		add_post_meta( $post_ID, '_wp_attachment_context', $context, true );
***************
*** 3776,3781 ****
--- 3823,3834 ----
  	$backup_sizes = get_post_meta( $post->ID, '_wp_attachment_backup_sizes', true );
  	$file = get_attached_file( $post_id );
  
+ 	$intermediate_sizes = array();
+ 	foreach ( get_intermediate_image_sizes() as $size ) {
+ 		if ( $intermediate = image_get_intermediate_size( $post_id, $size ) )
+ 			$intermediate_sizes[] = $intermediate;
+ 	}
+ 
  	if ( is_multisite() )
  		delete_transient( 'dirsize_cache' );
  
***************
*** 3784,3809 ****
  	wp_delete_object_term_relationships($post_id, array('category', 'post_tag'));
  	wp_delete_object_term_relationships($post_id, get_object_taxonomies($post->post_type));
  
! 	$wpdb->query( $wpdb->prepare( "DELETE FROM $wpdb->postmeta WHERE meta_key = '_thumbnail_id' AND meta_value = %d", $post_id ));
  
  	$comment_ids = $wpdb->get_col( $wpdb->prepare( "SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID = %d", $post_id ));
! 	if ( ! empty( $comment_ids ) ) {
! 		do_action( 'delete_comment', $comment_ids );
! 		foreach ( $comment_ids as $comment_id )
! 			wp_delete_comment( $comment_id, true );
! 		do_action( 'deleted_comment', $comment_ids );
! 	}
  
  	$post_meta_ids = $wpdb->get_col( $wpdb->prepare( "SELECT meta_id FROM $wpdb->postmeta WHERE post_id = %d ", $post_id ));
! 	if ( !empty($post_meta_ids) ) {
! 		do_action( 'delete_postmeta', $post_meta_ids );
! 		$in_post_meta_ids = "'" . implode("', '", $post_meta_ids) . "'";
! 		$wpdb->query( "DELETE FROM $wpdb->postmeta WHERE meta_id IN($in_post_meta_ids)" );
! 		do_action( 'deleted_postmeta', $post_meta_ids );
! 	}
  
  	do_action( 'delete_post', $post_id );
! 	$wpdb->query( $wpdb->prepare( "DELETE FROM $wpdb->posts WHERE ID = %d", $post_id ));
  	do_action( 'deleted_post', $post_id );
  
  	$uploadpath = wp_upload_dir();
--- 3837,3854 ----
  	wp_delete_object_term_relationships($post_id, array('category', 'post_tag'));
  	wp_delete_object_term_relationships($post_id, get_object_taxonomies($post->post_type));
  
! 	delete_metadata( 'post', null, '_thumbnail_id', $post_id, true ); // delete all for any posts.
  
  	$comment_ids = $wpdb->get_col( $wpdb->prepare( "SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID = %d", $post_id ));
! 	foreach ( $comment_ids as $comment_id )
! 		wp_delete_comment( $comment_id, true );
  
  	$post_meta_ids = $wpdb->get_col( $wpdb->prepare( "SELECT meta_id FROM $wpdb->postmeta WHERE post_id = %d ", $post_id ));
! 	foreach ( $post_meta_ids as $mid )
! 		delete_metadata_by_mid( 'post', $mid );
  
  	do_action( 'delete_post', $post_id );
! 	$wpdb->delete( $wpdb->posts, array( 'ID' => $post_id ) );
  	do_action( 'deleted_post', $post_id );
  
  	$uploadpath = wp_upload_dir();
***************
*** 3818,3828 ****
  	}
  
  	// remove intermediate and backup images if there are any
! 	foreach ( get_intermediate_image_sizes() as $size ) {
! 		if ( $intermediate = image_get_intermediate_size($post_id, $size) ) {
! 			$intermediate_file = apply_filters('wp_delete_file', $intermediate['path']);
! 			@ unlink( path_join($uploadpath['basedir'], $intermediate_file) );
! 		}
  	}
  
  	if ( is_array($backup_sizes) ) {
--- 3863,3871 ----
  	}
  
  	// remove intermediate and backup images if there are any
! 	foreach ( $intermediate_sizes as $intermediate ) {
! 		$intermediate_file = apply_filters( 'wp_delete_file', $intermediate['path'] );
! 		@ unlink( path_join($uploadpath['basedir'], $intermediate_file) );
  	}
  
  	if ( is_array($backup_sizes) ) {
***************
*** 3838,3844 ****
  	if ( ! empty($file) )
  		@ unlink($file);
  
! 	clean_post_cache($post_id);
  
  	return $post;
  }
--- 3881,3887 ----
  	if ( ! empty($file) )
  		@ unlink($file);
  
! 	clean_post_cache( $post );
  
  	return $post;
  }
***************
*** 4002,4008 ****
   *
   * @since 2.1.0
   *
!  * @param string $mime MIME type
   * @return string|bool
   */
  function wp_mime_type_icon( $mime = 0 ) {
--- 4045,4051 ----
   *
   * @since 2.1.0
   *
!  * @param string|int $mime MIME type or attachment ID.
   * @return string|bool
   */
  function wp_mime_type_icon( $mime = 0 ) {
***************
*** 4150,4157 ****
   *
   * @since 3.0.0
   * @param string $post_type Post type.
!  * @param bool $full Optional.  Returns a full WHERE statement instead of just an 'andalso' term.
!  * @param int $post_author Optional.  Query posts having a single author ID.
   * @return string SQL WHERE code that can be added to a query.
   */
  function get_posts_by_author_sql( $post_type, $full = true, $post_author = null ) {
--- 4193,4200 ----
   *
   * @since 3.0.0
   * @param string $post_type Post type.
!  * @param bool $full Optional. Returns a full WHERE statement instead of just an 'andalso' term.
!  * @param int $post_author Optional. Query posts having a single author ID.
   * @return string SQL WHERE code that can be added to a query.
   */
  function get_posts_by_author_sql( $post_type, $full = true, $post_author = null ) {
***************
*** 4288,4307 ****
  /**
   * Updates posts in cache.
   *
-  * @usedby update_page_cache() Aliased by this function.
-  *
   * @package WordPress
   * @subpackage Cache
   * @since 1.5.1
   *
   * @param array $posts Array of post objects
   */
! function update_post_cache(&$posts) {
! 	if ( !$posts )
  		return;
  
  	foreach ( $posts as $post )
! 		wp_cache_add($post->ID, $post, 'posts');
  }
  
  /**
--- 4331,4348 ----
  /**
   * Updates posts in cache.
   *
   * @package WordPress
   * @subpackage Cache
   * @since 1.5.1
   *
   * @param array $posts Array of post objects
   */
! function update_post_cache( &$posts ) {
! 	if ( ! $posts )
  		return;
  
  	foreach ( $posts as $post )
! 		wp_cache_add( $post->ID, $post, 'posts' );
  }
  
  /**
***************
*** 4321,4397 ****
   *
   * @uses do_action() Calls 'clean_post_cache' on $id before adding children (if any).
   *
!  * @param int $id The Post ID in the cache to clean
   */
! function clean_post_cache($id) {
  	global $_wp_suspend_cache_invalidation, $wpdb;
  
! 	if ( !empty($_wp_suspend_cache_invalidation) )
  		return;
  
! 	$id = (int) $id;
! 
! 	if ( 0 === $id )
  		return;
  
! 	wp_cache_delete($id, 'posts');
! 	wp_cache_delete($id, 'post_meta');
  
! 	clean_object_term_cache($id, 'post');
  
  	wp_cache_delete( 'wp_get_archives', 'general' );
  
! 	do_action('clean_post_cache', $id);
  
! 	if ( $children = $wpdb->get_col( $wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE post_parent = %d", $id) ) ) {
! 		foreach ( $children as $cid ) {
  			// Loop detection
! 			if ( $cid == $id )
  				continue;
! 			clean_post_cache( $cid );
  		}
  	}
  
  	if ( is_multisite() )
! 		wp_cache_delete( $wpdb->blogid . '-' . $id, 'global-posts' );
! }
! 
! /**
!  * Alias of update_post_cache().
!  *
!  * @see update_post_cache() Posts and pages are the same, alias is intentional
!  *
!  * @package WordPress
!  * @subpackage Cache
!  * @since 1.5.1
!  *
!  * @param array $pages list of page objects
!  */
! function update_page_cache(&$pages) {
! 	update_post_cache($pages);
! }
! 
! /**
!  * Will clean the page in the cache.
!  *
!  * Clean (read: delete) page from cache that matches $id. Will also clean cache
!  * associated with 'all_page_ids' and 'get_pages'.
!  *
!  * @package WordPress
!  * @subpackage Cache
!  * @since 2.0.0
!  *
!  * @uses do_action() Will call the 'clean_page_cache' hook action.
!  *
!  * @param int $id Page ID to clean
!  */
! function clean_page_cache($id) {
! 	clean_post_cache($id);
! 
! 	wp_cache_delete( 'all_page_ids', 'posts' );
! 	wp_cache_delete( 'get_pages', 'posts' );
! 
! 	do_action('clean_page_cache', $id);
  }
  
  /**
--- 4362,4405 ----
   *
   * @uses do_action() Calls 'clean_post_cache' on $id before adding children (if any).
   *
!  * @param object|int $post The post object or ID to remove from the cache
   */
! function clean_post_cache( $post ) {
  	global $_wp_suspend_cache_invalidation, $wpdb;
  
! 	if ( ! empty( $_wp_suspend_cache_invalidation ) )
  		return;
  
! 	$post = get_post( $post );
! 	if ( empty( $post ) )
  		return;
  
! 	wp_cache_delete( $post->ID, 'posts' );
! 	wp_cache_delete( $post->ID, 'post_meta' );
  
! 	clean_object_term_cache( $post->ID, $post->post_type );
  
  	wp_cache_delete( 'wp_get_archives', 'general' );
  
! 	do_action( 'clean_post_cache', $post->ID, $post );
! 
! 	if ( 'page' == $post->post_type ) {
! 		wp_cache_delete( 'all_page_ids', 'posts' );
! 		wp_cache_delete( 'get_pages', 'posts' );
! 		do_action( 'clean_page_cache', $post->ID );
! 	}
  
! 	if ( $children = $wpdb->get_results( $wpdb->prepare("SELECT ID, post_type FROM $wpdb->posts WHERE post_parent = %d", $post->ID) ) ) {
! 		foreach ( $children as $child ) {
  			// Loop detection
! 			if ( $child->ID == $post->ID )
  				continue;
! 			clean_post_cache( $child );
  		}
  	}
  
  	if ( is_multisite() )
! 		wp_cache_delete( $wpdb->blogid . '-' . $post->ID, 'global-posts' );
  }
  
  /**
***************
*** 4580,4626 ****
  	if ( defined('WP_IMPORTING') )
  		return;
  
! 	$data = array( 'post_id' => $post_id, 'meta_value' => '1' );
! 	if ( get_option('default_pingback_flag') ) {
! 		$wpdb->insert( $wpdb->postmeta, $data + array( 'meta_key' => '_pingme' ) );
! 		do_action( 'added_postmeta', $wpdb->insert_id, $post_id, '_pingme', 1 );
! 	}
! 	$wpdb->insert( $wpdb->postmeta, $data + array( 'meta_key' => '_encloseme' ) );
! 	do_action( 'added_postmeta', $wpdb->insert_id, $post_id, '_encloseme', 1 );
  
  	wp_schedule_single_event(time(), 'do_pings');
  }
  
  /**
!  * Hook used to prevent page/post cache and rewrite rules from staying dirty.
!  *
!  * Does two things. If the post is a page and has a template then it will
!  * update/add that template to the meta. For both pages and posts, it will clean
!  * the post cache to make sure that the cache updates to the changes done
!  * recently. For pages, the rewrite rules of WordPress are flushed to allow for
!  * any changes.
!  *
!  * The $post parameter, only uses 'post_type' property and 'page_template'
!  * property.
   *
   * @since 2.3.0
   * @access private
-  * @uses $wp_rewrite Flushes Rewrite Rules.
   *
   * @param int $post_id The ID in the database table for the $post
   * @param object $post Object type containing the post information
   */
! function _save_post_hook($post_id, $post) {
! 	if ( $post->post_type == 'page' ) {
! 		clean_page_cache($post_id);
! 		// Avoid flushing rules for every post during import.
! 		if ( !defined('WP_IMPORTING') ) {
! 			global $wp_rewrite;
! 			$wp_rewrite->flush_rules(false);
! 		}
! 	} else {
! 		clean_post_cache($post_id);
! 	}
  }
  
  /**
--- 4588,4611 ----
  	if ( defined('WP_IMPORTING') )
  		return;
  
! 	if ( get_option('default_pingback_flag') )
! 		add_post_meta( $post_id, '_pingme', '1' );
! 	add_post_meta( $post_id, '_encloseme', '1' );
  
  	wp_schedule_single_event(time(), 'do_pings');
  }
  
  /**
!  * Hook used to prevent page/post cache from staying dirty when a post is saved.
   *
   * @since 2.3.0
   * @access private
   *
   * @param int $post_id The ID in the database table for the $post
   * @param object $post Object type containing the post information
   */
! function _save_post_hook( $post_id, $post ) {
! 	clean_post_cache( $post );
  }
  
  /**
***************
*** 4653,4664 ****
  	if ( empty($_post->post_parent) || $_post->ID == $_post->post_parent )
  		return;
  
! 	$id = $_post->ancestors[] = $_post->post_parent;
  	while ( $ancestor = $wpdb->get_var( $wpdb->prepare("SELECT `post_parent` FROM $wpdb->posts WHERE ID = %d LIMIT 1", $id) ) ) {
  		// Loop detection: If the ancestor has been seen before, break.
  		if ( ( $ancestor == $_post->ID ) || in_array($ancestor,  $_post->ancestors) )
  			break;
! 		$id = $_post->ancestors[] = $ancestor;
  	}
  }
  
--- 4638,4649 ----
  	if ( empty($_post->post_parent) || $_post->ID == $_post->post_parent )
  		return;
  
! 	$id = $_post->ancestors[] = (int) $_post->post_parent;
  	while ( $ancestor = $wpdb->get_var( $wpdb->prepare("SELECT `post_parent` FROM $wpdb->posts WHERE ID = %d LIMIT 1", $id) ) ) {
  		// Loop detection: If the ancestor has been seen before, break.
  		if ( ( $ancestor == $_post->ID ) || in_array($ancestor,  $_post->ancestors) )
  			break;
! 		$id = $_post->ancestors[] = (int) $ancestor;
  	}
  }
  
***************
*** 4902,4908 ****
   *
   * @param int|object $post Post ID or post object
   * @param string $output Optional. OBJECT, ARRAY_A, or ARRAY_N.
!  * @param string $filter Optional sanitation filter.  @see sanitize_post()
   * @return mixed Null if error or post object if success
   */
  function &wp_get_post_revision(&$post, $output = OBJECT, $filter = 'raw') {
--- 4887,4893 ----
   *
   * @param int|object $post Post ID or post object
   * @param string $output Optional. OBJECT, ARRAY_A, or ARRAY_N.
!  * @param string $filter Optional sanitation filter. @see sanitize_post()
   * @return mixed Null if error or post object if success
   */
  function &wp_get_post_revision(&$post, $output = OBJECT, $filter = 'raw') {
***************
*** 5084,5090 ****
   * @uses wp_find_hierarchy_loop()
   *
   * @param int $post_parent ID of the parent for the post we're checking.
!  * @parem int $post_ID ID of the post we're checking.
   *
   * @return int The new post_parent for the post.
   */
--- 5069,5075 ----
   * @uses wp_find_hierarchy_loop()
   *
   * @param int $post_parent ID of the parent for the post we're checking.
!  * @param int $post_ID ID of the post we're checking.
   *
   * @return int The new post_parent for the post.
   */
***************
*** 5110,5116 ****
  	if ( isset( $loop[$post_ID] ) )
  		return 0;
  
! 	// There's a loop, but it doesn't contain $post_ID.  Break the loop.
  	foreach ( array_keys( $loop ) as $loop_member )
  		wp_update_post( array( 'ID' => $loop_member, 'post_parent' => 0 ) );
  
--- 5095,5101 ----
  	if ( isset( $loop[$post_ID] ) )
  		return 0;
  
! 	// There's a loop, but it doesn't contain $post_ID. Break the loop.
  	foreach ( array_keys( $loop ) as $loop_member )
  		wp_update_post( array( 'ID' => $loop_member, 'post_parent' => 0 ) );
  
***************
*** 5183,5190 ****
  	if ( $post && $thumbnail_id && get_post( $thumbnail_id ) ) {
  		$thumbnail_html = wp_get_attachment_image( $thumbnail_id, 'thumbnail' );
  		if ( ! empty( $thumbnail_html ) ) {
! 			update_post_meta( $post->ID, '_thumbnail_id', $thumbnail_id );
! 			return true;
  		}
  	}
  	return false;
--- 5168,5174 ----
  	if ( $post && $thumbnail_id && get_post( $thumbnail_id ) ) {
  		$thumbnail_html = wp_get_attachment_image( $thumbnail_id, 'thumbnail' );
  		if ( ! empty( $thumbnail_html ) ) {
! 			return update_post_meta( $post->ID, '_thumbnail_id', $thumbnail_id );
  		}
  	}
  	return false;
***************
*** 5221,5226 ****
--- 5205,5224 ----
  }
  
  /**
+  * Deletes auto-drafts for new posts that are > 7 days old
+  *
+  * @since 3.4.0
+  */
+ function wp_delete_auto_drafts() {
+ 	global $wpdb;
+ 
+ 	// Cleanup old auto-drafts more than 7 days old
+ 	$old_posts = $wpdb->get_col( "SELECT ID FROM $wpdb->posts WHERE post_status = 'auto-draft' AND DATE_SUB( NOW(), INTERVAL 7 DAY ) > post_date" );
+ 	foreach ( (array) $old_posts as $delete )
+ 		wp_delete_post( $delete, true ); // Force delete
+ }
+ 
+ /**
   * Filters the request to allow for the format prefix.
   *
   * @access private
***************
*** 5328,5331 ****
  		wp_update_term_count( $tt_ids, $taxonomy );
  	}
  }
! ?>
--- 5326,5350 ----
  		wp_update_term_count( $tt_ids, $taxonomy );
  	}
  }
! 
! /**
!  * Adds any posts from the given ids to the cache that do not already exist in cache
!  *
!  * @since 3.4.0
!  *
!  * @access private
!  *
!  * @param array $post_ids ID list
!  * @param bool $update_term_cache Whether to update the term cache. Default is true.
!  * @param bool $update_meta_cache Whether to update the meta cache. Default is true.
!  */
! function _prime_post_caches( $ids, $update_term_cache = true, $update_meta_cache = true ) {
! 	global $wpdb;
! 
! 	$non_cached_ids = _get_non_cached_ids( $ids, 'posts' );
! 	if ( !empty( $non_cached_ids ) ) {
! 		$fresh_posts = $wpdb->get_results( sprintf( "SELECT $wpdb->posts.* FROM $wpdb->posts WHERE ID IN (%s)", join( ",", $non_cached_ids ) ) );
! 
! 		update_post_caches( $fresh_posts, 'any', $update_term_cache, $update_meta_cache );
! 	}
! }
